/*
 * This file is generated by jOOQ.
 */
package de.ship.pia.emailcollector.jooq.tables;


import de.ship.pia.emailcollector.jooq.Public;
import de.ship.pia.emailcollector.jooq.tables.records.VVersionRecord;

import java.util.function.Function;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Function1;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Records;
import org.jooq.Row1;
import org.jooq.Schema;
import org.jooq.SelectField;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VVersion extends TableImpl<VVersionRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>public.v_version</code>
     */
    public static final VVersion V_VERSION = new VVersion();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VVersionRecord> getRecordType() {
        return VVersionRecord.class;
    }

    /**
     * The column <code>public.v_version.db_version</code>.
     */
    public final TableField<VVersionRecord, Integer> DB_VERSION = createField(DSL.name("db_version"), SQLDataType.INTEGER, this, "");

    private VVersion(Name alias, Table<VVersionRecord> aliased) {
        this(alias, aliased, null);
    }

    private VVersion(Name alias, Table<VVersionRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view());
    }

    /**
     * Create an aliased <code>public.v_version</code> table reference
     */
    public VVersion(String alias) {
        this(DSL.name(alias), V_VERSION);
    }

    /**
     * Create an aliased <code>public.v_version</code> table reference
     */
    public VVersion(Name alias) {
        this(alias, V_VERSION);
    }

    /**
     * Create a <code>public.v_version</code> table reference
     */
    public VVersion() {
        this(DSL.name("v_version"), null);
    }

    public <O extends Record> VVersion(Table<O> child, ForeignKey<O, VVersionRecord> key) {
        super(child, key, V_VERSION);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Public.PUBLIC;
    }

    @Override
    public VVersion as(String alias) {
        return new VVersion(DSL.name(alias), this);
    }

    @Override
    public VVersion as(Name alias) {
        return new VVersion(alias, this);
    }

    @Override
    public VVersion as(Table<?> alias) {
        return new VVersion(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VVersion rename(String name) {
        return new VVersion(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VVersion rename(Name name) {
        return new VVersion(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VVersion rename(Table<?> name) {
        return new VVersion(name.getQualifiedName(), null);
    }

    // -------------------------------------------------------------------------
    // Row1 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row1<Integer> fieldsRow() {
        return (Row1) super.fieldsRow();
    }

    /**
     * Convenience mapping calling {@link SelectField#convertFrom(Function)}.
     */
    public <U> SelectField<U> mapping(Function1<? super Integer, ? extends U> from) {
        return convertFrom(Records.mapping(from));
    }

    /**
     * Convenience mapping calling {@link SelectField#convertFrom(Class,
     * Function)}.
     */
    public <U> SelectField<U> mapping(Class<U> toType, Function1<? super Integer, ? extends U> from) {
        return convertFrom(toType, Records.mapping(from));
    }
}
